{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 01-10-2001
  Versión actual: 1.0.0
  Fecha versión actual: 01-10-2001
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit BuscarPedidoProveedor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RdxFramePedidosProveedor, RdxBotones, ExtCtrls, StdCtrls, RdxCampos,
  RdxBarras, RdxTitulos, RdxPaneles;

type
  TfrBuscarPedidoProveedor = class(TRdxFramePedidosProveedor)
    brBuscar: TRdxBarraInferior;
    pnlScroll: TRdxScrollPanel;
    cBuscarProveedor: TRdxCabecera;
    eCodigoPedido: TLabel;
    Codigo: TRdxEdit;
    eNIF: TLabel;
    NIF: TRdxEdit;
    eNombre: TLabel;
    Nombre: TRdxEdit;
    eCodigoProveedor: TLabel;
    CodigoProveedor: TRdxEdit;
    bBuscar: TRdxBoton;
    bCerrar: TRdxBoton;
    Almacen: TRdxEdit;
    Label1: TLabel;
    procedure bCerrarClick(Sender: TObject);
    procedure bBuscarClick(Sender: TObject);
  private
    procedure RecogerDatos;
  protected
    procedure BuscarPedido; override;
    function CloseFrame : boolean; override;
  public
    constructor Create(AOwner : TComponent); override;
  end;

var
  frBuscarPedidoProveedor: TfrBuscarPedidoProveedor;

implementation
{$R *.DFM}

uses
  Tipos, DB, Mensajes, StrFunc, Configuracion, Literales;

var
  Campos : String;
  Valores : Variant;
  Contador : Integer;

procedure TfrBuscarPedidoProveedor.bCerrarClick(Sender: TObject);
begin
  inherited;
  CloseFrame;
end;

procedure TfrBuscarPedidoProveedor.BuscarPedido;
var
  Respuesta : integer;
  Resultado : Boolean;
begin
  if Contador <> -1 then begin
    TablaPedidosProveedor.DisableControls;

    if Contador = 0 then
      Resultado := TablaPedidosProveedor.LocateNext(Campos, Valores[Contador], [loCaseInsensitive, loPartialKey])
    else
      Resultado := TablaPedidosProveedor.LocateNext(Campos, Valores, [loCaseInsensitive, loPartialKey]);
    if (Resultado = false) then
    begin
        Respuesta := VerMensajePregunta(msgIrInicio);
        case Respuesta of
          IDYES: TablaPedidosProveedor.First;
        end;
    end;
    TablaPedidosProveedor.EnableControls;
  end;
end;

constructor TfrBuscarPedidoProveedor.Create(AOwner: TComponent);
begin
  if not (AOwner is TRdxFramePedidosProveedor) then
    exit;
  inherited Create(AOwner);
  Entidad := entPedidoProveedor;
  ConfigurarFrame(Self, Self.Entidad);

  Contador := -1;
  Campos := '';
  Valores := VarArrayOf([null, null, null, null, null]);

  TablaPedidosProveedor := (AOwner as TRdxFramePedidosProveedor).TablaPedidosProveedor;
  with TablaPedidosProveedor do begin
    Codigo.MaxLength := FieldByName('CODIGO').Size;
    Nombre.MaxLength := FieldByName('NOMBRE').Size;
    CodigoProveedor.MaxLength := FieldByName('CODIGOPROVEEDOR').Size;
    NIF.MaxLength := FieldByName('NIFCIF').Size;
    Almacen.MaxLength := FieldByName('NOMBREALMACEN').Size;
  end;
end;

procedure TfrBuscarPedidoProveedor.bBuscarClick(Sender: TObject);
begin
  RecogerDatos;
  if Contador <> -1 then
    BuscarPedido
  else
    VerMensaje(msgNoParametros);
end;

procedure TfrBuscarPedidoProveedor.RecogerDatos;
begin
  Campos := '';
  Contador := -1;

  if not EsCadenaVacia(Codigo.Text) then
  begin
    Contador := Contador + 1;
    Campos := Campos + 'CODIGO';
    Valores[Contador] := Trim(Codigo.Text);
  end;

  if not EsCadenaVacia(CodigoProveedor.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'CODIGOPROVEEDOR';
    Valores[Contador] := Trim(CodigoProveedor.Text);
  end;

  if not EsCadenaVacia(Nombre.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'NOMBRE';
    Valores[Contador] := Trim(Nombre.Text);
  end;

  if not EsCadenaVacia(Nif.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'NIFCIF';
    Valores[Contador] := Trim(Nif.Text);
  end;

  if not EsCadenaVacia(Almacen.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'NOMBREALMACEN';
    Valores[Contador] := Trim(Almacen.Text);
  end;
end;

function TfrBuscarPedidoProveedor.CloseFrame: boolean;
begin
  FCodigoPedido := TablaPedidosProveedor.FieldByName('CODIGO').AsString;
  Result := inherited CloseFrame;
end;


end.
